# -*- coding: euc-jp -*-
require "numru/ggraph"
include NumRu


itr = 10 # xy
itr = 30 # sphere



dir   = ARGV[0]
t     = ARGV[1].to_i



#< DCLΥץ >
DCL.gropn(2)
DCL.sgpset('lcntl', false)   # ʸᤷʤ
DCL.sgpset('lfull',true)     # ɽ
DCL.uzfact(0.75)             # ɸʸ󥵥 0.75 
DCL.sgpset('lfprop',true)    # ץݡʥեȤȤ

DCL.sldiv('y',2,2)           # 2x2˲ʬ, 'y'=yoko: 墪墪...


def ext_lonlat_array( gphys )
  # extend an array
  lon  = gphys.coord('lon' ).val
  lat  = gphys.coord('lat' ).val
  time = gphys.coord('time').val
  array = gphys.val
  vname = gphys.name

  ext_lon   = NArrayMiss.float( lon.size+1 )
  ext_lat   = NArrayMiss.float( lat.size+2 )
  ext_array = NArrayMiss.float( lon.size+1, lat.size+2, time.size )
  ext_lon[0..lon.size-1] = lon[0..lon.size-1]
  ext_lon[-1] = 360.0
  ext_lat[1..lat.size] = lat[0..lat.size-1]
  ext_lat[0] = -90.0
  ext_lat[-1] =  90.0
  ext_array[0..lon.size-1,1..lat.size,true] = array[0..lon.size-1,0..lat.size-1,true]
  ext_array[0..lon.size-1,0,true] = array[0..lon.size-1,1,true].mean(0)
  ext_array[0..lon.size-1,-1,true] = array[0..lon.size-1,-2,true].mean(0)
  ext_array[-1,true,true] = ext_array[0,true,true]

  va_ext_lon = VArray.new( ext_lon, {"long_name"=>"lon", "units"=>"degrees_east"}, "lon" )
  ax_ext_lon = Axis.new.set_pos(va_ext_lon)
  va_ext_lat = VArray.new( ext_lat, {"long_name"=>"lat", "units"=>"degrees_north"}, "lat" )
  ax_ext_lat = Axis.new.set_pos(va_ext_lat)
  if gphys.get_att('missing_value').nil?
    va_ext_array = VArray.new( ext_array, {"long_name"=>vname, "units"=>"1"}, vname )
  else
    rmiss = gphys.get_att('missing_value')[0]
    va_ext_array = VArray.new( ext_array, {"long_name"=>vname, "units"=>"1", "missing_value"=>[rmiss]}, vname )
  end
  gphys_out = GPhys.new( Grid.new(ax_ext_lon,ax_ext_lat,gphys.axis('time')), va_ext_array )

  return gphys_out
end

def draw_each_panel( itr, dir, vname, t, vnameice )

  plev =  10e2
  plev = 100e2
  plev = 500e2
  plev = 700e2

  ncfn  = dir + '/' + vname + '.nc'
  gphys = GPhys::NetCDF_IO.open(ncfn, vname)

  time = gphys.coord('time').val
  #tm = gphys.shape[3]

  gphys = gphys.cut('time'=>time[t]..time[t])

  gphys = ext_lonlat_array( gphys )
  #gphys = gphys.cut('time'=>time[t]).cut('level'=>plev).cut('lat'=>0..90)
  gphys = gphys.cut('time'=>time[t])
  #gphys = gphys.copy


  #gphys = gphys * 1.0e-3
  #gphys.units = 'km'

  #z = gphys.axis('time').pos.convert_units( Units['days since 1979-1-1 00:00:0.0'] )
  #z.units = 'days'
  #gphys.axis('time').set_pos(z)
  #p gphys.axis('time').pos

  if gphys.get_att('missing_value').nil?
    DCL.glpset('lmiss',false)
  else
    rmiss = gphys.get_att('missing_value')[0]
    DCL.glpset('lmiss',true)
    DCL.glpset('rmiss',rmiss)
  end


  if plev == 10e2
    # for 10 hPa
    levels = [26.0,26.2,26.4,26.6,26.8,27.0,27.2,27.4,27.6,27.8,28.0,28.2,28.4,28.6,28.8,29.0,29.2,29.4,29.6,29.8,30.0,30.2,30.4,30.6,30.8,31.0,31.2,31.4,31.6,31.8,32.0]
    patterns = [10999,12999,15999,17999,20999,22999,25999,27999,30999,32999,35999,37999,40999,42999,45999,47999,50999,52999,55999,57999,60999,62999,65999,67999,70999,72999,75999,80999,85999,90999,92999,95999]
  elsif plev == 50e2
    # for 50 hPa
    levels = [18.0,18.2,18.4,18.6,18.8,19.0,19.2,19.4,19.6,19.8,20.0,20.2,20.4,20.6,20.8,21.0,21.2,21.4,21.6,21.8,22.0]
    patterns = [10999,12999,15999,20999,25999,30999,32999,35999,40999,45999,50999,55999,60999,65999,70999,72999,75999,80999,85999,90999,92999,95999]
  elsif plev == 500e2
    levels = [26.0,26.2,26.4,26.6,26.8,27.0,27.2,27.4,27.6,27.8,28.0,28.2,28.4,28.6,28.8,29.0,29.2,29.4,29.6,29.8,30.0,30.2,30.4,30.6,30.8,31.0,31.2,31.4,31.6,31.8,32.0]
    for i in 0..(levels.length-1)
      levels[i] = levels[i] - 26.0
      levels[i] = levels[i] / 2.0
      levels[i] = levels[i] + 4.5
    end
    patterns = [10999,12999,15999,17999,20999,22999,25999,27999,30999,32999,35999,37999,40999,42999,45999,47999,50999,52999,55999,57999,60999,62999,65999,67999,70999,72999,75999,80999,85999,90999,92999,95999]
  end

  if vname == "QH2OVap"
    # Earth QH2OVap
    levels = [1e-5, 0.5e-3, 1.0e-3, 1.5e-3, 2.0e-3, 2.5e-3, 3.0e-3, 3.5e-3, 4.0e-3, 4.5e-3, 5.0e-3, 5.5e-3, 6.0e-3, 6.5e-3, 7.0e-3, 7.5e-3, 8.0e-3, 8.5e-3, 9.0e-3, 9.5e-3, 10.0e-3]
    patterns = [12999,15999,17999,20999,25999,27999,30999,35999,40999,50999,60999,65999,70999,75999,80999,85999,90999,95999,97999,99999]
  elsif vname == "VIH2OVap"
    # Earth VIH2OVap
    gphys.long_name = "Precipitable water"
    gphys.units = "kg m-2"
    levels = [1e-1, 0.5e1, 1.0e1, 1.5e1, 2.0e1, 2.5e1, 3.0e1, 3.5e1, 4.0e1, 4.5e1, 5.0e1, 5.5e1, 6.0e1, 6.5e1, 7.0e1, 7.5e1, 8.0e1, 8.5e1, 9.0e1, 9.5e1, 10.0e1]
    for i in 0..levels.size-1
      #  levels[i] = levels[i] * 5e-3
      levels[i] = levels[i] * 7.5e-1
    end
    patterns = [1,12999,15999,17999,20999,22999,25999,27999,30999,35999,40999,50999,60999,65999,70999,75999,80999,85999,90999,92999,95999,97999]
  elsif vname == "VIH2OLiq" || vname == "VIH2OSol"
    # Earth VIH2OLiq, Sol
    if vname == "VIH2OLiq"
      gphys.long_name = "LWP"
    elsif vname == "VIH2OSol"
      gphys.long_name = "IWP"
    end
    gphys.units = "kg m-2"
    levels = [1e-1, 0.5e1, 1.0e1, 1.5e1, 2.0e1, 2.5e1, 3.0e1, 3.5e1, 4.0e1, 4.5e1, 5.0e1, 5.5e1, 6.0e1, 6.5e1, 7.0e1, 7.5e1, 8.0e1, 8.5e1, 9.0e1, 9.5e1, 10.0e1]
    for i in 0..levels.size-1
      #  levels[i] = levels[i] * 5e-3
      levels[i] = levels[i] * 7.5e-3
    end
    patterns = [1,12999,15999,17999,20999,22999,25999,27999,30999,35999,40999,50999,60999,65999,70999,75999,80999,85999,90999,92999,95999,97999]
  elsif vname == "SurfTemp"
    # Earth SurfTemp
    gphys.long_name = "Surface Temperature"
#    gphys.units = "K"
    levels = [200, 205, 210, 215, 220, 225, 230, 235, 240, 245, 250, 255, 260, 265, 270, 275, 280, 285, 290, 295, 300, 305, 310]
    patterns = [1,12999,15999,17999,20999,22999,25999,27999,30999,32999,35999,40999,45999,50999,60999,65999,70999,75999,80999,85999,90999,92999,95999,97999]
  end

  #DCL.sgscmn(14) # blue-white-red


  #< GGraph ˤ  >
  if itr == 10 then
#    GGraph.set_fig 'itr'=>itr, 'viewport'=>[0.15,0.75,0.1,0.6], 'window'=>[0,360,-90,90]
    GGraph.set_fig 'itr'=>itr, 'viewport'=>[0.15,0.90,0.1,0.8], 'window'=>[0,360,-90,90]
    GGraph.set_map 'coast_world'=>true, 'grid'=>false
#    GGraph.set_map 'coast_world'=>false, 'grid'=>false
    GGraph.set_axes('xlabelint'=>90)
    GGraph.set_axes('ylabelint'=>30)
  elsif itr == 30
    axis = [135.0,30,0]
    #  axis = [0.0,90,0]
    axis = [(135.0-((time[t]%365.0)*2.0))%360.0,30,0]
    p axis
    GGraph.set_fig 'itr'=>itr, 'map_axis'=>axis,'map_radius'=>90.0, 'viewport'=>[0.15,0.85,0.1,0.6]
    GGraph.set_map 'vpt_boundary'=>false, 'coast_world'=>true#, 'grid'=>false
#    GGraph.set_map 'vpt_boundary'=>false, 'coast_world'=>false#, 'grid'=>false
    DCL::sgpset('lclip', false)
  else
    exit
  end


  GGraph.tone( gphys, true, 'lev'=>levels, 'pat'=>patterns, 'map_axes'=>true, 'annotate'=>true )
  GGraph.color_bar

  if vnameice != nil
    ncfnice  = dir + '/' + vnameice + '.nc'
    gphys = GPhys::NetCDF_IO.open(ncfnice, vnameice)
    gphys = gphys.cut('time'=>time[t])
#    GGraph.contour( gphys, false, 'lev'=>[1.0e-3], 'index'=>2, 'annotate'=>false )
    GGraph.tone( -gphys+1.0e-3, false, 'ltone'=>false, 'annotate'=>false )
  end

end

vnameice = ARGV[6]
vname = ARGV[2]
draw_each_panel( itr, dir, vname, t, vnameice )
#DCL.grfrm
#ncfn  = dir + '/' + vname + '.nc'
#gphys = GPhys::NetCDF_IO.open(ncfn, vname)
#time = gphys.coord('time').val
#line = sprintf( "Time = %07.2f days", time[t] )
#DCL::sgtxv(0.5, 0.5, line)
vname = ARGV[3]
draw_each_panel( itr, dir, vname, t, vnameice )
vname = ARGV[4]
draw_each_panel( itr, dir, vname, t, vnameice )
vname = ARGV[5]
draw_each_panel( itr, dir, vname, t, vnameice )

DCL.grcls
